/************************************************************************
 ************************************************************************
                                                                         
 Function :                                                              
 
 int         colourArrayLength(ColourArray colourArray);
 void        colourArrayDelete(ColourArray colourArray);
 Colour      colourArrayGetElement(ColourArray colourArray, 
                                    int index);                                                                         
 ColourArray colourArrayMake(int size);
 ColourArray colourArrayInsertElement(ColourArray colorArray,
                                      Colour colour,
				      int index);                                                                        
-----------------------
jpeg handling routines
unsigned char * is a jsample
ColourArray     colourArrayFromJsample(unsigned char * jsample , int length);
unsigned char * colourArrayToJsample(ColourArray colArr);
----------------------- 
 Module description : To handle the necessary functions to 
                      colourArray. To allow users to create, delete and
		      get colourArray element. Module use the contract method !!!
                                                                         
                                                                         
                                                                         
                                                                         
*************************************************************************
*************************************************************************/

#ifndef _COLOURARRAY_H
#define _COLOURARRAY_H

#include "colour.h"
#include "bool.h"

typedef Colour *Array;

typedef struct
{
  int          arraySize;
  Array        array;  
} ColourArray;


/*-------------------------------------------------------------
 Function : colourArrayMake                                                   
                                                               
 Argument : int                                                   
                                                               
 ReturnType : colourArray                                                 
                                                               
 Description : Make a new array.
                                                               
                                                               
--------------------------------------------------------------*/
ColourArray colourArrayMake(int size);




/*-------------------------------------------------------------
 Function : colourArrayDelete                                                   
                                                               
 Argument : colourArray                                                   
                                                               
 ReturnType : void                                                 
                                                               
 Description : Delete the array                                               
                                                               
                                                              
--------------------------------------------------------------*/
void colourArrayDelete(ColourArray ColourArray);



/*-------------------------------------------------------------
 Function : colourArrayGetElement                                                   
                                                               
 Argument : colourArray                                                   
                                                               
 ReturnType : colour                                                 
                                                               
 Description : Get the element at index, the caller must
               ensure that the index is in the array size.
               The array index start at 0 to N-1.                                                   
                                                               
                                                               
--------------------------------------------------------------*/
Colour colourArrayGetElement(ColourArray ColourArray, int index);


/*-------------------------------------------------------------
 Function : colourArrayInsertElement                                                   
                                                               
 Argument : colourArray,
            colour,
            int
                                                               
 ReturnType : colourArray                                                  
                                                               
 Description : Insert a colour element at index position. 
               It's up to the caller to ensure that indexpos
               is a valid position to insert the colour to.
               If there already exist a colour at index i will
               be overwritten.
                                                               
                                                               
--------------------------------------------------------------*/
ColourArray colourArrayInsertElement(ColourArray ColourArray,
				     Colour colour,
				     int index);


/*-------------------------------------------------------------
 Function : colourArrayLength                                            
                                                               
 Argument : colourArray                                                   
                                                               
 ReturnType : int                                                 
                                                               
 Description : Return the colourArray length 1 -> N.                                                               
                                                               
--------------------------------------------------------------*/
int colourArrayLength(ColourArray colourArray);


ColourArray colourArrayFromJsample(unsigned char * jsample , int length);

unsigned char * colourArrayToJsample(ColourArray colArr);



#endif /*_COLOURARRAY_H */
















