/************************************************************************
 ************************************************************************
                                                                         
 Module : debug.c                                                              
                                                                         
                                                                         
                                                                         
 Changes :                                                               
 13/9 S.A  Added some indentation for debug mode.
           Add possibility to debug separate module.

 15/9 S.A  Add degugValue for ppmLoad, ppmSave, object, objectList 
	   
 
	   !!!! Cant'n handle moduleValue > 9.
           The flagS must be unique ex -DDEBUG=23456789, 1 < VALIDFLAG < 10;
	   INTEGER 1 = DEBUG AS DEFAULT BY SYSTEM.
                                                                         
************************************************************************* 
*************************************************************************/

#include <string.h>
#include <stdio.h>


static int PAD_VALUE = 0;

static const int MOD_VALUE = 10;
static const int DIV_VALUE = 10;

/* DEGUG is by default = 1 */

static const short DEBUG_DEFAULT_VALUE    = 1;

/* Module level = 2 */
static const short DEBUG_COLOUR_VALUE     = 2;
static const short DEBUG_BITMAP_VALUE     = 2;
static const short DEBUG_ARRAY_VALUE      = 2;
static const short DEBUG_VECTOR_VALUE     = 2;

/* Module level = 3 */
static const short DEBUG_OBJECT_VALUE     = 3;
static const short DEBUG_SURFACE_VALUE    = 3;


/* Module level = 4 */
static const short DEBUG_LIST_VALUE       = 4;

/* Module level = 5 */
static const short DEBUG_OBJ_LIST_VALUE   = 5;
static const short DEBUG_LIGHT_LIST_VALUE = 5;


/* Module level = 6 */
static const short DEBUG_HIT_POINT_VALUE  = 6;
static const short DEBUG_RAY_VALUE        = 6;
static const short DEBUG_CAMERA_VALUE     = 6;

/* Module level = 7 */
static const short DEBUG_WORLD_VALUE      = 7;
static const short DEBUG_TRACE_VALUE      = 7;


/* Module level = 8 */
static const short DEBUG_PPMSAVE_VALUE    = 8;
static const short DEBUG_PPMLOAD_VALUE    = 8;

static const short DEBUG_TRIANGLE_VALUE   = 9;
static const short DEBUG_GLOBE_VALUE      = 9;
static const short DEBUG_ORIENTATION_VALUE= 9;
static const short DEBUG_PLANE_VALUE      = 9;
static const short DEBUG_LIGHT_VALUE      = 9;



/* Module level = 9 */
/*-------------------------------------------------------------
 Function : getModuleValue                                                   
                                                               
 Purpus : Compare the 'module' string by all the ......c files
          if equal then return current moduleValue.
                                                               
                                                               
--------------------------------------------------------------*/
static int getModuleValue(char* module)
{
  if (strcmp(module, "colour.c") == 0)
    return DEBUG_COLOUR_VALUE;
  
  else if (strcmp(module, "colourArray.c") == 0)
    return DEBUG_ARRAY_VALUE;

  else if (strcmp(module, "bitmap.c") == 0)
    return DEBUG_BITMAP_VALUE;

  else if (strcmp(module, "vector.c") == 0)
    return DEBUG_VECTOR_VALUE;

  else if (strcmp(module, "ppmSave.c") == 0)
    return DEBUG_PPMSAVE_VALUE;
  
  else if (strcmp(module, "ppmLoad.c") == 0)
    return DEBUG_PPMLOAD_VALUE;

  else if (strcmp(module, "object.c") == 0)
    return DEBUG_OBJECT_VALUE;
  
  else if (strcmp(module, "surface.c") == 0)
    return DEBUG_SURFACE_VALUE;

  else if (strcmp(module, "list.c") == 0)
    return DEBUG_LIST_VALUE;

  else if (strcmp(module, "objectList.c") == 0)
    return DEBUG_OBJ_LIST_VALUE;
  
  else if (strcmp(module, "lightList.c") == 0)
    return DEBUG_LIGHT_LIST_VALUE;

  else if (strcmp(module, "hitPoint.c") == 0)
    return DEBUG_HIT_POINT_VALUE;
  
  else if (strcmp(module, "world.c") == 0)
    return DEBUG_WORLD_VALUE;

  else if (strcmp(module, "ray.c") == 0)
    return DEBUG_RAY_VALUE;
  
  else if (strcmp(module, "camera.c") == 0)
    return DEBUG_CAMERA_VALUE;
  
  else if (strcmp(module, "triangle.c") == 0)
    return DEBUG_TRIANGLE_VALUE;

  else if (strcmp(module, "globe.c") == 0)
    return DEBUG_GLOBE_VALUE;

  else if (strcmp(module, "plane.c") == 0)
    return DEBUG_PLANE_VALUE; 

  else if (strcmp(module, "light.c") == 0)
    return DEBUG_LIGHT_VALUE;

  else if (strcmp(module, "tracer99.c") == 0)
    return DEBUG_TRACE_VALUE;

  else if (strcmp(module, "orientation.c") == 0)
    return DEBUG_ORIENTATION_VALUE;

  else return DEBUG_DEFAULT_VALUE;
} 


/*-------------------------------------------------------------
 Function : padString                                                   
                                                               
 Purpus : Make a indentation string.                                                     
                                                               
                                                               
--------------------------------------------------------------*/
static void padString(void)
{
  /* local variable */
  int   counter = 0;
  
  while(counter < PAD_VALUE + 1)
    {
      printf("%s"," ");
      counter++;
    }

   return ;
}


/*-------------------------------------------------------------
 Function : debugOutFunc                                                   

 Purpus : Test if the module was activated for debug print.                                                     
                                                               
                                                               
--------------------------------------------------------------*/
void debugOutFunc(int command, char* module )
{
  int moduleValue;
  int leastSignificant;
  int commandValue = command;

  moduleValue   = getModuleValue(module);
  

  /* DEBUG = command and it is instantiated default by 1 */
  if (command > 1)
    {
 

      PAD_VALUE = PAD_VALUE - 1;
      
      /* 
	 Test if the command includes the moduleValue. 
	 If moduleValue exists in command, then all the module
	 functions will print debug information.
      */
      while (commandValue > MOD_VALUE)
	{
	  /* Modulo calculation */
	  leastSignificant = commandValue % MOD_VALUE;
	  
	  if (leastSignificant == moduleValue)
	    {
	      padString();
	      printf("Exit\n");
	    }
	  
	  commandValue = commandValue / DIV_VALUE;
	}
      
      
      if (commandValue == moduleValue)
	{
	  padString();
	  printf("Exit\n");
	}
    }
 
  return ;
  
}


/*-------------------------------------------------------------
 Function : debugInfunc                                                   
                                                               
 Purpus : Test if we shall activate the debug functions that appers in 
          the module or not.
                                                               
                                                               
--------------------------------------------------------------*/
void debugInFunc(int command, char* funcName, char* module)
{
  int moduleValue;
  int leastSignificant;
  int commandValue = command;

  moduleValue = getModuleValue(module);

  /* DEBUG = command and it is instantiated default by 1 */
  if (command > 1)
    {
      /* 
	 Test if the command includes the moduleValue. 
	 If moduleValue exists in command, then all the module
	 functions will print debug information.
      */
      while (commandValue > MOD_VALUE)
	{
	  /* Modulo calculation */
	  leastSignificant = commandValue % MOD_VALUE;
	  
	  if (leastSignificant == moduleValue)
	    {
	      padString();
	      printf("%s %d\n", funcName, __LINE__);
	    }
	  
	  commandValue = commandValue / DIV_VALUE;
	}
      
      
      
      if (commandValue == moduleValue)
	{
	  padString();
	  printf("%s %d\n", funcName, __LINE__);
	}
      
      PAD_VALUE = PAD_VALUE + 1;
      
    }

    return ;

}







