/************************************************************************
 ************************************************************************
                                                                         
 Function :
 void debugInFunc(int command, char* funcName, char* module);
 void debugOutFunc(int command, char* module);

                                                                         
                                                                         
                                                                         
 Module description :
 Every new debug<..> must be added in debug.c and below.
                                                                          
                                                                         
                                                                         
                                                                         
*************************************************************************
*************************************************************************/


#ifndef _DEBUG_H
#define _DEBUH_H



/*-------------------------------------------------------------
 Function : debugInFunc                                                   
                                                               
 Argument : DEBUG,   " is the debug variable from gcc"
            char*,   " string from user "
	    __FILE__ " static preprocessor command "
                                                               
 ReturnType :  void                                                
                                                               
 Description : Test if DEBUG flag is instantiated with the
               module constant, if TRUE the the debugPrint is activated.
                                                               
                                                               
--------------------------------------------------------------*/
void debugInFunc(int command, char* funcName, char* module);
 

/*-------------------------------------------------------------
 Function : debugOutFunc                                                   
                                                               
 Argument : DEBUG,   " is the debug variable from gcc"
            __FILE__ " static preprocessor command "
                                                               
 ReturnType : void                                                 
                                                               
 Description : Test if DEBUG flag is instantiated with the
               module constant, if TRUE the the debugExit is activated.

--------------------------------------------------------------*/
void debugOutFunc(int command, char* module);
 

#ifdef DEBUG
#define debugColour(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugColourArray(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugBitmap(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugVector(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugPPMLoad(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugPPMSave(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugObject(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugTriangle(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugGlobe(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugPlane(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugLight(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugSurface(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugList(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugObjectList(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugLightList(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugHitPoint(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugRay(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugCamera(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugWorld(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugTrace(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugOrientation(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugScanLine(str) (debugInFunc(DEBUG, str, __FILE__))
#define debugExit() (debugOutFunc(DEBUG, __FILE__))
#else
#ifdef NDEBUG
#define debugColour(str)
#define debugColourArray(str)
#define debugBitmap(str)
#define debugVector(str)
#define debugPPMLoad(str)
#define debugPPMSave(str)
#define debugObject(str)
#define debugTriangle(str)
#define debugGlobe(str)
#define debugPlane(str)
#define debugLight(str)
#define debugSurface(str)
#define debugList(str)
#define debugObjectList(str)
#define debugLightList(str)
#define debugHitPoint(str)
#define debugRay(str)
#define debugCamera(str)
#define debugWorld(str)
#define debugTrace(str)
#define debugOrientation(str)
#define debugScanLine(str)
#define debugExit()
#else
#define debugColour(str) int n
#define debugColourArray(str)
#define debugBitmap(str)
#define debugVector(str)
#define debugPPMLoad(str)
#define debugPPMSave(str)
#define debugObject(str)
#define debugTriangle(str)
#define debugGlobe(str)
#define debugPlane(str)
#define debugLight(str)
#define debugSurface(str)
#define debugList(str)
#define debugObjectList(str)
#define debugLightList(str)
#define debugHitPoint(str)
#define debugCamera(str)
#define debugRay(str)
#define debugWorld(str)
#define debugTrace(str)
#define debugOrientation(str)
#define debugScanLine(str)
#define debugExit()
#endif /* NDEBUG */
#endif /* DEBUG */



#endif /* _DEBUG_H */
