/************************************************************************
 ************************************************************************
                                                                         

 Module description :


 This module start the tracer.

	     
*************************************************************************
*************************************************************************/

#include "bool.h"
#include "input.h"
#include "global.h"
#include "bitmap.h"
#include "jpegIO.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <ctype.h>
#include <dirent.h>



int inputParse(char *input)
{
	
	int length;
	char ext[5];
	char *tmp;
	
	
	if (input == NULL)
		return -1;
	
	ext[4] = '\0';
	
	length = strlen(input);
	
	tmp = input + (length - 4) * sizeof(char);
	
	strcpy(ext , tmp);
	
	
	ext[0] = tolower(ext[0]);
	ext[1] = tolower(ext[1]);
	ext[2] = tolower(ext[2]);
	ext[3] = tolower(ext[3]);
	

	if (strcmp(ext , "jpeg") == 0 || strcmp(ext , ".jpg") == 0)
		return JPEG;

	if (strcmp(ext , ".ppm") == 0)
		return PPM;
		
	if ((ext[0] == '.') || (ext[1] == '.') || (ext[2] == '.'))
		return UNKNOWN;	

	return DIRECTORY;
}





int inputScanDir(char *dir , char * outdir , int width , int height)
{
	dirent_t	*dp;
	char		inname[80], outname[80];
	Bitmap		bitmap , bitmap2;
	DIR		*dfd;



	dfd = opendir(dir);
	if (dfd == NULL)
		{
			printf("no dir\n");
			exit (1);
		}
	
	dp = readdir(dfd);
	
	while (dp != NULL)
	{
	  if (inputParse(dp->d_name) == JPEG)
	    {
	      strcpy(inname , dir);
	      strcat(inname , "/");
	      strcat(inname , dp->d_name);
	      printf("read %s\n",inname);
	      bitmap = jpegIOLoad(inname , width , height);
	      bitmap2 = bitmapMake(WIDTH , HEIGHT);
	      bitmap2 = bitmapResizeCol(bitmap , HEIGHT , bitmap2);
	      strcpy(outname , outdir);
	      strcat(outname , "/");
	      strcat(outname , dp->d_name);
	      jpegIOSave(bitmap2 , outname , 100);
	      bitmapDelete(bitmap);
	      bitmapDelete(bitmap2);
	    }
	  
	  
	  dp = readdir(dfd);
	}
	
	closedir(dfd);

	


   return 0;
}
