/************************************************************************
 ************************************************************************
                                                                         

 Module description :


 This module start the tracer.

	     
*************************************************************************
*************************************************************************/

#include "colour.h"
#include "bitmap.h"
#include "bool.h"
#include "ppmIO.h"
#include "jpegIO.h"
#include "input.h"
#include "global.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

/*-------------------------------------------------------------
 Function : main                                                   
                                                               
 Purpus :                                                      
                                                               
                                                               
--------------------------------------------------------------*/
int main(int argc, char** argv)
{
	Bitmap  bitmap , bitmap2;
	


  int   width = 0;
  int   height = 0;
  char  c;
  char *outfile , *infile, *dir;
  char* validArgs = "i:o:w:h:?";



  while (TRUE)
    {      
      c = getopt(argc, argv, validArgs);
      
      if(c == -1)
		break;
	
      /* 
       * When we find one illegal option, 
       * we check the rest, and terminate the progam 
       */
      if((c == '?') || (c == 'H'))
		{
		  while(getopt(argc, argv, validArgs) != EOF);
			  printf("thumber [flag | flags]\n");
			  printf("flags:	-i infile or indir\n");
			  printf("			-o outfile or outdir\n");
			  printf("			-w width\n");
			  printf("			-h height\n");
		}


	switch (c)
		{		  
		case 'w' :
		    width = atoi(optarg);
	    	break;
	    	 
		case 'h' :
			height = atoi(optarg);
	    	break;

		case 'o' :
			outfile = argv[optind-1];
	    	break;

		case 'i' :
			infile = argv[optind-1];
	    	break;
			
		default :
	 		break;
		} 
      
    }

	if (width == 0 && height == 0)
		{
			printf("Must have width or height or both\n");
			exit (1);
		}


	switch(inputParse(infile))
		{
		case UNKNOWN :
			printf("unknown filetype, not jpeg or ppm\n");
			break;

		case JPEG :
			bitmap = jpegIOLoad(infile , width , height);
			printf("bitmap read\n");
			bitmap2 = bitmapMake(WIDTH , HEIGHT);
			bitmap2 = bitmapResizeCol(bitmap , HEIGHT , bitmap2);
			jpegIOSave(bitmap2 , outfile , 100);

			break;
		
		case PPM :
			printf("input is PPM file\n");
			break;
			
		case DIRECTORY :
			if (inputParse(outfile) != DIRECTORY)
				{
					printf("if input is dir then so must output\n");
					exit (1);
				}
			inputScanDir(infile , outfile , width , height);
			break;
			
		default :
			printf("not parsable\n");
			break;
		}


   return 0;
}

