/************************************************************************
 ************************************************************************
                                                                         
 Function :
 Bitmap    ppmIOLoad (char* filename)
 Bool      ppmIOSave (Bitmap picture , char* filename , char type)
	    
 Module description : Supplying the procedures to read and write a
                      bitmap to/from disk as a ppm_file,
		      binary or ascii type is optional.
*************************************************************************
*************************************************************************/
#ifndef _PPMIO_H
#define _PPMIO_H

#include "bitmap.h"


#define AUTHOR "#Coded by d96san and d96eho\n#Frogs of c\n"

#define MAXNUMBERSIZE 10000
#define MAXNUMBERLENGTH 5
#define MAXCHARINT 255

#define NEWLINE '\n'
#define TAB     8
#define CRETURN 13
#define SPACE   32
#define SQUARE  35
#define NOLL    48
#define NIO     57

/*-------------------------------------------------------------
 Function : ppmIOLoad                                                   
                                                               
 Argument : char* filename  is filename of ppm
 
 ReturnType : Bitmap                                                 
                                                               
 Description : by extracting the information out of a ppm_file
               we then insert that data in a bitmap structure
	       and then return it.
--------------------------------------------------------------*/
Bitmap ppmIOLoad (char* filename);

/*-------------------------------------------------------------
 Function : ppmIOSave                                                   
                                                               
 Argument : Bitmap picture
            char*  filename  is filename of ppm
	    char   type       is the type of ppm 't' or 'b'
	    
 ReturnType : bool          TRUE is a success
                            FALSE is fail
                                                               
 Description : by extracting the information out of a ppm_file
               we then insert that data in a bitmap structure
	       and then return it.
--------------------------------------------------------------*/
Bool ppmIOSave (Bitmap picture , char* filename , char type);

#endif /* _PPMIO_H */
