/************************************************************************
 ************************************************************************
                                                                         
 Function :                                                              
 
 int         scanLineLength(ScanLine scanLine);
 void        scanLineDelete(ScanLine scanLine);
 Colour      scanLineGetElement(ScanLine scanLine, 
                                    int index);                                                                         
 ScanLine scanLineMake(int size);
 ScanLine scanLineInsertElement(ScanLine colorArray,
                                      Colour colour,
				      int index);                                                                        
ScanLine scanLineResize(ScanLine scanLine , int width);
-----------------------
jpeg handling routines
unsigned char * is a jsample
ScanLine     scanLineFromJsample(unsigned char * jsample , int length);
unsigned char * scanLineToJsample(ScanLine colArr);
----------------------- 
 Module description : To handle the necessary functions to 
                      scanLine. To allow users to create, delete and
		      get scanLine element. Module use the contract method !!!
                                                                         
                                                                         
                                                                         
                                                                         
*************************************************************************
*************************************************************************/

#ifndef _SCANLINE_H
#define _SCANLINE_H

#include "colour.h"
#include "bool.h"

typedef Colour *Array;

typedef struct
{
  int          size;
  Array        array;  
} ScanLine;


/*-------------------------------------------------------------
 Function : scanLineMake                                                   
                                                               
 Argument : int                                                   
                                                               
 ReturnType : scanLine                                                 
                                                               
 Description : Make a new array.
                                                               
                                                               
--------------------------------------------------------------*/
ScanLine scanLineMake(int size);




/*-------------------------------------------------------------
 Function : scanlineDelete                                                   
                                                               
 Argument : scanLine                                                   
                                                               
 ReturnType : void                                                 
                                                               
 Description : Delete the array                                               
                                                               
                                                              
--------------------------------------------------------------*/
void scanLineDelete(ScanLine scanLine);



/*-------------------------------------------------------------
 Function : scanLineGetElement                                                   
                                                               
 Argument : scanLine                                                   
                                                               
 ReturnType : colour                                                 
                                                               
 Description : Get the element at index, the caller must
               ensure that the index is in the array size.
               The array index start at 0 to N-1.                                                   
                                                               
                                                               
--------------------------------------------------------------*/
Colour scanLineGetElement(ScanLine ScanLine, int index);


/*-------------------------------------------------------------
 Function : scanLineInsertElement                                                   
                                                               
 Argument : scanLine,
            colour,
            int
                                                               
 ReturnType : scanLine                                                  
                                                               
 Description : Insert a colour element at index position. 
               It's up to the caller to ensure that indexpos
               is a valid position to insert the colour to.
               If there already exist a colour at index i will
               be overwritten.
                                                               
                                                               
--------------------------------------------------------------*/
ScanLine scanLineInsertElement(ScanLine ScanLine,
				     Colour colour,
				     int index);


/*-------------------------------------------------------------
 Function : scanLineLength                                            
                                                               
 Argument : scanLine                                                   
                                                               
 ReturnType : int                                                 
                                                               
 Description : Return the scanLine length 1 -> N.                                                               
                                                               
--------------------------------------------------------------*/
int scanLineLength(ScanLine scanLine);


ScanLine scanLineResize(ScanLine sLine1 , int width , ScanLine sLine2);

ScanLine scanLineFromJsample(unsigned char * jsample , int length,
								ScanLine sLine);

unsigned char * scanLineToJsample(ScanLine colArr);



#endif /*_SCANLINE_H */
















